<?php
/**
 * sample code for GiroCheckout integration of a paydirekt capture transaction
 *
 * Call from command line in two steps:
 * 1) Without arguments for initial AUTH transaction: php PaydirektCapture.php
 * 2) With reference code from AUTH for CAPTURE: php PaydirektCapture.php 43290-48329043-43289
 * 
 * @filesource
 * @package Samples
 * @version $Revision: 109 $ / $Date: 2015-06-01 13:37:30 +0200 (Mo, 01 Jun 2015) $
 */
require_once '../../GiroCheckout_SDK/GiroCheckout_SDK.php';

/**
 * configuration of the merchants identifier, project and password
 * this information can be found in the GiroCockpit's project settings
 */
$merchantID = 350000;
$projectID = 7375;
$projectPassword = "qv6RzWwXs47i";

$strReference = "";

if( $argc == 1 ) {
  /* STEP 1: init Paydirekt AUTH transaction and parameters */
  try {

    $oCart = new GiroCheckout_SDK_Request_Cart();
    $oCart->addItem( "Bobbycar", 3, 2599, "800001303" );
    $oCart->addItem( "Helm", 1, 1853 );

    $request = new GiroCheckout_SDK_Request('paydirektTransaction');
    $request->setSecret($projectPassword);
    $request->addParam('merchantId',$merchantID)
            ->addParam('projectId',$projectID)
            ->addParam('merchantTxId',"123456")
            ->addParam('amount',4452)
            ->addParam('currency','EUR')
            ->addParam('purpose','Zweck')
            ->addParam('type', 'AUTH')
            ->addParam('shippingAmount','0')
            ->addParam('shippingAddresseFirstName','Heiko')
            ->addParam('shippingAddresseLastName','Meier')
            ->addParam('shippingZipCode','88699')
            ->addParam('shippingCity','Frickingen')
            ->addParam('shippingCountry','DE')
            ->addParam('orderAmount',123)
            ->addParam('orderId','9837898')
            ->addParam('cart', $oCart)
            ->addParam('urlRedirect','http://localhost')
            ->addParam('urlNotify','http://localhost')

            //the hash field is auto generated by the SDK
            ->submit();

    print_r($request->getResponseRaw());
    echo "\n";

    // if transaction succeeded update your local system and redirect the customer
    if($request->requestHasSucceeded()) {
      $request->getResponseParam('rc');
      $request->getResponseParam('msg');
      $strReference = $request->getResponseParam('reference');
      $request->getResponseParam('redirect');

      //$request->redirectCustomerToPaymentProvider();
    }

    // if the transaction did not succeed update your local system, get the responsecode and notify the customer
    else {
      $request->getResponseParam('rc');
      $request->getResponseParam('msg');
      $request->getResponseMessage($request->getResponseParam('rc'),'DE');
    }
  }
  catch (Exception $e) { echo $e->getMessage(); }
}
else {
  // STEP 2: Do Capture
  $strReference = $argv[1];

  if( !empty($strReference) ) {
    echo "\nOrig Trx Ref: $strReference\n";

    /* init giropay transaction and parameters */
    try {  
      $request = new GiroCheckout_SDK_Request('paydirektCapture');
      $request->setSecret($projectPassword);
      $request->addParam('merchantId',$merchantID)
              ->addParam('projectId',$projectID)
              ->addParam('merchantTxId',"123456")
              ->addParam('amount',2000)  // Anzahlung
              ->addParam('currency','EUR')
              ->addParam('purpose','Capture des vorangeg. Auth')
              ->addParam('reference', $strReference)
              ->addParam('final', 0)

              //the hash field is auto generated by the SDK
              ->submit();

      print_r($request->getResponseRaw());
      echo "\n";

      /* if transaction succeeded update your local system an redirect the customer */
      if($request->requestHasSucceeded()) {
        $request->getResponseParam('rc');
        $request->getResponseParam('msg');
        $request->getResponseParam('reference');
        $request->getResponseParam('redirect');

        $request->redirectCustomerToPaymentProvider();
      }

      /* if the transaction did not succeed update your local system, get the responsecode and notify the customer */
      else {
        $request->getResponseParam('rc');
        $request->getResponseParam('msg');
        $request->getResponseMessage($request->getResponseParam('rc'),'DE');
      }
    }
    catch (Exception $e) { echo $e->getMessage(); }
  }
}