<?php
/**
 * sample code for GiroCheckout integration of a paydirekt transaction
 *
 * @filesource
 * @package Samples
 * @version $Revision: 109 $ / $Date: 2015-06-01 13:37:30 +0200 (Mo, 01 Jun 2015) $
 */
define('__GIROCHECKOUT_SDK_DEBUG__',true);
apache_setenv( "GIROCHECKOUT_SERVER", "http://localhost.gs" );
require_once '../../GiroCheckout_SDK/GiroCheckout_SDK.php';

/**
 * configuration of the merchants identifier, project and password
 * this information can be found in the GiroCockpit's project settings
 */
$merchantID = 350000;
$projectID = 14084;
$projectPassword = "jpwv7mFWyp2Y";

/* init giropay transaction and parameters */
try {
  
  $oCart = new GiroCheckout_SDK_Request_Cart();
  $oCart->addItem( "Bobbycar", 3, 2599, "800001303" );
  $oCart->addItem( "Helm", 1, 1853 );
  
	$request = new GiroCheckout_SDK_Request('paydirektTransaction');
	$request->setSecret($projectPassword);
	$request->addParam('merchantId',$merchantID)
	        ->addParam('projectId',$projectID)
	        ->addParam('merchantTxId',"123456")
	        ->addParam('amount',4452)
	        ->addParam('currency','EUR')
	        ->addParam('purpose','Zweck')
          //->addParam('type', 'SALE')
	        ->addParam('shippingAmount','0')
	        ->addParam('shippingAddresseFirstName','Heiko')
	        ->addParam('shippingAddresseLastName','Meier')
	        ->addParam('shippingZipCode','88699')
	        ->addParam('shippingCity','Frickingen')
	        ->addParam('shippingCountry','DE')
	        ->addParam('orderAmount',123)
	        ->addParam('orderId','9837-898')
	        ->addParam('cart', $oCart)
	        ->addParam('urlRedirect','https://dev.girosolution.de/redirect.php')
	        ->addParam('urlNotify','https://dev.girosolution.de/notify.php')

	        //the hash field is auto generated by the SDK
	        ->submit();
  
  echo "<pre>";print_r($request->getResponseRaw());echo "</pre>";
  //echo "\n";
  
	/* if transaction succeeded update your local system and redirect the customer */
	if($request->requestHasSucceeded()) {
    $request->getResponseParam('rc');
    $request->getResponseParam('msg');
    $request->getResponseParam('reference');
    $request->getResponseParam('redirect');

    $request->redirectCustomerToPaymentProvider();
	}
	
	/* if the transaction did not succeed update your local system, get the responsecode and notify the customer */
	else {
    $request->getResponseParam('rc');
    $request->getResponseParam('msg');
    $request->getResponseMessage($request->getResponseParam('rc'),'DE');
	}
}
catch (Exception $e) { echo $e->getMessage(); }